/*

class SimAttr {
public:
   int n;		// attribute number
   char t;		// attribute type 'q' quantitative 'o' ordinal
   float s;		// scale factor;
   float e;		// exponent
   SimAttr(void) { n = 0; t = 'q'; s = 1; e = 1; }
} SimAttr;

class SimClass {
public:
   int len;		// number of attributes
   float e;		// exponent
   SimAttr a[32];	// attribute definitions
   SimClass(void) { len = 0; e = 1; };
};

SimClass sim;

COMMAND( grSimilarity )
{
   CHK_CUR;
   CHK_ARGS( <, 3, "usage: grSimilarity A1:[o|q] A2:[o|q] ..." );

   if( vcursor == NIL ) RET_ERROR("bad context");

   for( int i = 1; i < argc; i++ )
   {
      int n;
      char t;
      if( sscanf( argv[i], "%d:%c", &n, &t ) != 2 )
      {
         sprintf( interp->result, "bad argument '%s'", argv[i] );
         return TCL_ERROR;
      }
      if( t != 'o' && t != 'q' ) RET_ERROR("bad type")
      if( n < 0 || n > 31 ) RET_ERROR("bad index")

      // got here, so current argument is OK
      //
      sim.a[i-1].n = n;
      sim.a[i-1].t = t;

      // Now must create widgets and associative arrays and bind arrays
      // to the SimAttr variables.
      //
   }
   sim.len = argc - 1;
}

MATH_FUNC( sim )
{
   CHK_CUR;
   result->type = TCL_DOUBLE;
   if( vcursor == NIL || fcursor == NIL ) RET_ERROR("bad context")
   double retval = 0;

   for( int i = 0; i < sim.len; i++ )
   {
      if( sim.a[i].t == 'q' )
         retval += sim.a[i].s *
               pow(
                 abs( current_hi->GetAttr( 3, sim.a[i].n ) -
                      current_hi->GetAttr( 5, sim.a[i].n ) ),
                 sim.a[i].e
               );
      else
         retval += sim.a[i].s * (
            current_hi->GetAttr( 3, sim.a[i].n ) ==
            current_hi->GetAttr( 5, sim.a[i].n ) ? 1 : 0 );
   }
   retval = pow( retval, sim.e ) * fpcursor->m;

   result->doubleValue = retval;
   return TCL_OK;
}
*/
